Index: issm/trunk/src/c/parallel/balancedthickness.cpp
===================================================================
--- issm/trunk/src/c/parallel/balancedthickness.cpp	(revision 3096)
+++ issm/trunk/src/c/parallel/balancedthickness.cpp	(revision 3097)
@@ -149,5 +149,5 @@
 	_printf_("\n   %-34s %f seconds  \n","Model initialization elapsed time:",finish_init-start_init);
 	_printf_("   %-34s %f seconds  \n","Core solution elapsed time:",finish_core-start_core);
-	_printf_("   %-34s %f seconds\n\n","Total elapsed time:",finish-start);
+	_printf_("\n   %s %i hrs %i min %i sec\n\n","Total elapsed time:",int((finish-start)/3600),int(int(finish-start)%3600/60),int(finish-start)%60);
 	_printf_("closing MPI and Petsc\n");
 	PetscFinalize(); 
Index: issm/trunk/src/c/parallel/balancedvelocities.cpp
===================================================================
--- issm/trunk/src/c/parallel/balancedvelocities.cpp	(revision 3096)
+++ issm/trunk/src/c/parallel/balancedvelocities.cpp	(revision 3097)
@@ -147,5 +147,5 @@
 	_printf_("\n   %-34s %f seconds  \n","Model initialization elapsed time:",finish_init-start_init);
 	_printf_("   %-34s %f seconds  \n","Core solution elapsed time:",finish_core-start_core);
-	_printf_("   %-34s %f seconds\n\n","Total elapsed time:",finish-start);
+	_printf_("\n   %s %i hrs %i min %i sec\n\n","Total elapsed time:",int((finish-start)/3600),int(int(finish-start)%3600/60),int(finish-start)%60);
 	_printf_("closing MPI and Petsc\n");
 	PetscFinalize(); 
Index: issm/trunk/src/c/parallel/diagnostic.cpp
===================================================================
--- issm/trunk/src/c/parallel/diagnostic.cpp	(revision 3096)
+++ issm/trunk/src/c/parallel/diagnostic.cpp	(revision 3097)
@@ -183,5 +183,5 @@
 	_printf_("\n   %-34s %f seconds  \n","Model initialization elapsed time:",finish_init-start_init);
 	_printf_("   %-34s %f seconds  \n","Core solution elapsed time:",finish_core-start_core);
-	_printf_("   %-34s %f seconds\n\n","Total elapsed time:",finish-start);
+	_printf_("\n   %s %i hrs %i min %i sec\n\n","Total elapsed time:",int((finish-start)/3600),int(int(finish-start)%3600/60),int(finish-start)%60);
 	_printf_("closing MPI and Petsc\n");
 	PetscFinalize(); 
Index: issm/trunk/src/c/parallel/prognostic.cpp
===================================================================
--- issm/trunk/src/c/parallel/prognostic.cpp	(revision 3096)
+++ issm/trunk/src/c/parallel/prognostic.cpp	(revision 3097)
@@ -156,5 +156,5 @@
 	_printf_("\n   %-34s %f seconds  \n","Model initialization elapsed time:",finish_init-start_init);
 	_printf_("   %-34s %f seconds  \n","Core solution elapsed time:",finish_core-start_core);
-	_printf_("   %-34s %f seconds\n\n","Total elapsed time:",finish-start);
+	_printf_("\n   %s %i hrs %i min %i sec\n\n","Total elapsed time:",int((finish-start)/3600),int(int(finish-start)%3600/60),int(finish-start)%60);
 	_printf_("closing MPI and Petsc\n");
 	PetscFinalize(); 
Index: issm/trunk/src/c/parallel/slopecompute.cpp
===================================================================
--- issm/trunk/src/c/parallel/slopecompute.cpp	(revision 3096)
+++ issm/trunk/src/c/parallel/slopecompute.cpp	(revision 3097)
@@ -117,5 +117,5 @@
 	_printf_("\n   %-34s %f seconds  \n","Model initialization elapsed time:",finish_init-start_init);
 	_printf_("   %-34s %f seconds  \n","Core solution elapsed time:",finish_core-start_core);
-	_printf_("   %-34s %f seconds\n\n","Total elapsed time:",finish-start);
+	_printf_("\n   %s %i hrs %i min %i sec\n\n","Total elapsed time:",int((finish-start)/3600),int(int(finish-start)%3600/60),int(finish-start)%60);
 	_printf_("closing MPI and Petsc\n");
 	PetscFinalize(); 
Index: issm/trunk/src/c/parallel/steadystate.cpp
===================================================================
--- issm/trunk/src/c/parallel/steadystate.cpp	(revision 3096)
+++ issm/trunk/src/c/parallel/steadystate.cpp	(revision 3097)
@@ -202,5 +202,5 @@
 	_printf_("\n   %-34s %f seconds  \n","Model initialization elapsed time:",finish_init-start_init);
 	_printf_("   %-34s %f seconds  \n","Core solution elapsed time:",finish_core-start_core);
-	_printf_("   %-34s %f seconds\n\n","Total elapsed time:",finish-start);
+	_printf_("\n   %s %i hrs %i min %i sec\n\n","Total elapsed time:",int((finish-start)/3600),int(int(finish-start)%3600/60),int(finish-start)%60);
 	_printf_("closing MPI and Petsc\n");
 	PetscFinalize(); 
Index: issm/trunk/src/c/parallel/thermal.cpp
===================================================================
--- issm/trunk/src/c/parallel/thermal.cpp	(revision 3096)
+++ issm/trunk/src/c/parallel/thermal.cpp	(revision 3097)
@@ -150,5 +150,5 @@
 	_printf_("\n   %-34s %f seconds  \n","Model initialization elapsed time:",finish_init-start_init);
 	_printf_("   %-34s %f seconds  \n","Core solution elapsed time:",finish_core-start_core);
-	_printf_("   %-34s %f seconds\n\n","Total elapsed time:",finish-start);
+	_printf_("\n   %s %i hrs %i min %i sec\n\n","Total elapsed time:",int((finish-start)/3600),int(int(finish-start)%3600/60),int(finish-start)%60);
 	_printf_("closing MPI and Petsc\n");
 	PetscFinalize(); 
Index: issm/trunk/src/c/parallel/transient.cpp
===================================================================
--- issm/trunk/src/c/parallel/transient.cpp	(revision 3096)
+++ issm/trunk/src/c/parallel/transient.cpp	(revision 3097)
@@ -178,5 +178,5 @@
 	_printf_("\n   %-34s %f seconds  \n","Model initialization elapsed time:",finish_init-start_init);
 	_printf_("   %-34s %f seconds  \n","Core solution elapsed time:",finish_core-start_core);
-	_printf_("   %-34s %f seconds\n\n","Total elapsed time:",finish-start);
+	_printf_("\n   %s %i hrs %i min %i sec\n\n","Total elapsed time:",int((finish-start)/3600),int(int(finish-start)%3600/60),int(finish-start)%60);
 	_printf_("closing MPI and Petsc\n");
 	PetscFinalize(); 