Index: issm/trunk/src/c/objects/Icefront.cpp
===================================================================
--- issm/trunk/src/c/objects/Icefront.cpp	(revision 3105)
+++ issm/trunk/src/c/objects/Icefront.cpp	(revision 3107)
@@ -61,5 +61,5 @@
 }
 /*}}}*/
-		
+
 /*Object marshall*/
 /*FUNCTION Icefront Demarshall {{{1*/
@@ -339,5 +339,5 @@
 
 	//Compute load contribution for this segment:
-	SegmentPressureLoad(pe_g,matpar->GetRhoWater(),matpar->GetRhoIce(),matpar->GetG(),thickness_list,bed_list,normal,length,fill);
+	SegmentPressureLoad(pe_g,matpar->GetRhoWater(),matpar->GetRhoIce(),matpar->GetG(),thickness_list,bed_list,normal,length);
 		
 	#ifdef _DEBUGELEMENTS_
@@ -352,5 +352,4 @@
 		printf("normal (%g,%g)\n",normal[0],normal[1]);
 		printf("length %g\n",length);
-		printf("fill %i\n",fill);
 		printf("pe_g->terms\n");
 		for(i=0;i<numgrids*NDOF2;i++){
@@ -496,5 +495,5 @@
 
 	//Compute load contribution for this quad:
-	QuadPressureLoad(pe_g,matpar->GetRhoWater(),matpar->GetRhoIce(),matpar->GetG(),thickness_list_quad,bed_list_quad,normal1,normal2,normal3,normal4,&xyz_list_quad[0][0],fill);
+	QuadPressureLoad(pe_g,matpar->GetRhoWater(),matpar->GetRhoIce(),matpar->GetG(),thickness_list_quad,bed_list_quad,normal1,normal2,normal3,normal4,&xyz_list_quad[0][0]);
 
 
@@ -512,5 +511,4 @@
 		printf("normal3 (%g,%g,%g)\n",normal3[0],normal3[1],normal3[2]);
 		printf("normal4 (%g,%g,%g)\n",normal4[0],normal4[1],normal4[2]);
-		printf("fill %i\n",fill);
 		printf("pe_g->terms\n");
 		for(i=0;i<numgridsload*NDOF2;i++){
@@ -656,5 +654,5 @@
 
 	//Compute load contribution for this quad:
-	QuadPressureLoadStokes(pe_g,matpar->GetRhoWater(),matpar->GetRhoIce(),matpar->GetG(),thickness_list_quad,bed_list_quad,normal1,normal2,normal3,normal4,&xyz_list_quad[0][0],fill);
+	QuadPressureLoadStokes(pe_g,matpar->GetRhoWater(),matpar->GetRhoIce(),matpar->GetG(),thickness_list_quad,bed_list_quad,normal1,normal2,normal3,normal4,&xyz_list_quad[0][0]);
 
 	#ifdef _DEBUGELEMENTS_
@@ -671,5 +669,4 @@
 		printf("normal3 (%g,%g,%g)\n",normal3[0],normal3[1],normal3[2]);
 		printf("normal4 (%g,%g,%g)\n",normal4[0],normal4[1],normal4[2]);
-		printf("fill %i\n",fill);
 		printf("pe_g->terms\n");
 		for(i=0;i<numdofloads*NDOF4;i++){
@@ -845,5 +842,5 @@
 #define __FUNCT__ "Icefront::QuadPressureLoad"
 void Icefront::QuadPressureLoad(double* pe_g,double rho_water,double rho_ice,double gravity, double* thickness_list, double* bed_list, 
-		                              double* normal1,double* normal2,double* normal3,double* normal4,double* xyz_list, int fill){
+		                              double* normal1,double* normal2,double* normal3,double* normal4,double* xyz_list){
 	
 	
@@ -1103,5 +1100,5 @@
 #define __FUNCT__ "Icefront::QuadPressureLoadStokes"
 void Icefront::QuadPressureLoadStokes(double* pe_g,double rho_water,double rho_ice,double gravity, double* thickness_list, double* bed_list, 
-		                              double* normal1,double* normal2,double* normal3,double* normal4,double* xyz_list, int fill){
+		                              double* normal1,double* normal2,double* normal3,double* normal4,double* xyz_list){
 	
 	
@@ -1361,5 +1358,5 @@
 #define __FUNCT__ "Icefront::SegmentPressureLoad"
 
-void Icefront::SegmentPressureLoad(double* pe_g,double rho_water,double rho_ice,double gravity, double* thickness_list, double* bed_list, double* normal,double length,int fill){
+void Icefront::SegmentPressureLoad(double* pe_g,double rho_water,double rho_ice,double gravity, double* thickness_list, double* bed_list, double* normal,double length){
 
 	double   nx,ny;
Index: issm/trunk/src/c/objects/Icefront.h
===================================================================
--- issm/trunk/src/c/objects/Icefront.h	(revision 3105)
+++ issm/trunk/src/c/objects/Icefront.h	(revision 3107)
@@ -68,9 +68,9 @@
 		void  CreatePVectorDiagnosticStokes( Vec pg,void* inputs, int analysis_type,int sub_analysis_type);
 		void  GetDofList(int* doflist,int* pnumberofdofs);
-		void  SegmentPressureLoad(double* pe_g,double rho_water,double rho_ice,double gravity, double* thickness_list, double* bed_list, double* normal,double length,int fill);
+		void  SegmentPressureLoad(double* pe_g,double rho_water,double rho_ice,double gravity, double* thickness_list, double* bed_list, double* normal,double length);
 		void  QuadPressureLoad(double* pe_g,double rho_water,double rho_ice,double gravity, double* thickness_list, double* bed_list, 
-		                              double* normal1,double* normal2,double* normal3,double* normal4,double* xyz_list, int fill);
+		                              double* normal1,double* normal2,double* normal3,double* normal4,double* xyz_list);
 		void  QuadPressureLoadStokes(double* pe_g,double rho_water,double rho_ice,double gravity, double* thickness_list, double* bed_list, 
-		                              double* normal1,double* normal2,double* normal3,double* normal4,double* xyz_list, int fill);
+		                              double* normal1,double* normal2,double* normal3,double* normal4,double* xyz_list);
 		void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);
 		void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);