Index: issm/trunk/src/c/Bamgx/BamgObjects.h
===================================================================
--- issm/trunk/src/c/Bamgx/BamgObjects.h	(revision 3244)
+++ issm/trunk/src/c/Bamgx/BamgObjects.h	(revision 3245)
@@ -10,5 +10,5 @@
 
 #include "objects/Metric.h"
-#include "objects/DoubleAndInt4.h"
+#include "objects/DoubleAndInt.h"
 #include "objects/Direction.h"
 #include "objects/Vertex.h"
@@ -104,17 +104,17 @@
 
 	inline  void   Triangles::SetVertexFieldOn(){
-		for (long i=0;i<nbv;i++) 
+		for (int i=0;i<nbv;i++) 
 		 vertices[i].onGeometry=0;
-		for (long j=0;j<NbVerticesOnGeomVertex;j++ ) 
+		for (int j=0;j<NbVerticesOnGeomVertex;j++ ) 
 		 VerticesOnGeomVertex[j].SetOn();
-		for (long k=0;k<NbVerticesOnGeomEdge;k++ ) 
+		for (int k=0;k<NbVerticesOnGeomEdge;k++ ) 
 		 VerticesOnGeomEdge[k].SetOn();
 	}	       
 	inline  void   Triangles::SetVertexFieldOnBTh(){
-		for (long i=0;i<nbv;i++) 
+		for (int i=0;i<nbv;i++) 
 		 vertices[i].onGeometry=0;
-		for (long j=0;j<NbVertexOnBThVertex;j++ ) 
+		for (int j=0;j<NbVertexOnBThVertex;j++ ) 
 		 VertexOnBThVertex[j].SetOnBTh();
-		for (long k=0;k<NbVertexOnBThEdge;k++ ) 
+		for (int k=0;k<NbVertexOnBThEdge;k++ ) 
 		 VertexOnBThEdge[k].SetOnBTh();
 
Index: issm/trunk/src/c/Bamgx/objects/DoubleAndInt.h
===================================================================
--- issm/trunk/src/c/Bamgx/objects/DoubleAndInt.h	(revision 3245)
+++ issm/trunk/src/c/Bamgx/objects/DoubleAndInt.h	(revision 3245)
@@ -0,0 +1,19 @@
+#ifndef _DOUBLEANDINT_H_
+#define _DOUBLEANDINT_H_
+
+#include "../meshtype.h"
+
+namespace bamg {
+
+	class DoubleAndInt {
+		//class used by Triangles::MakeQuadrangles
+
+		public:
+			double q;
+			long i3j;
+
+			//Operators
+			int operator<(DoubleAndInt a){return q > a.q;}
+	};
+}
+#endif
Index: issm/trunk/src/c/Bamgx/objects/DoubleAndInt4.h
===================================================================
--- issm/trunk/src/c/Bamgx/objects/DoubleAndInt4.h	(revision 3244)
+++ 	(revision )
@@ -1,19 +1,0 @@
-#ifndef _DOUBLEANDINT4_H_
-#define _DOUBLEANDINT4_H_
-
-#include "../meshtype.h"
-
-namespace bamg {
-
-	class DoubleAndInt4 {
-		//class used by Triangles::MakeQuadrangles
-
-		public:
-			double q;
-			long i3j;
-
-			//Operators
-			int operator<(DoubleAndInt4 a){return q > a.q;}
-	};
-}
-#endif
Index: issm/trunk/src/c/Bamgx/objects/Geometry.h
===================================================================
--- issm/trunk/src/c/Bamgx/objects/Geometry.h	(revision 3244)
+++ issm/trunk/src/c/Bamgx/objects/Geometry.h	(revision 3245)
@@ -69,5 +69,5 @@
 			long Number(const GeometricalEdge * t) const  { return t - edges;}
 			long Number(const Curve * c) const  { return c - curves;}
-			void UnMarkEdges() {for (long i=0;i<nbe;i++) edges[i].SetUnMark();}
+			void UnMarkEdges() {for (int i=0;i<nbe;i++) edges[i].SetUnMark();}
 			GeometricalEdge *  ProjectOnCurve(const Edge & ,double,Vertex &,VertexOnGeom &) const ;
 			GeometricalEdge *  Contening(const R2 P,  GeometricalEdge * start) const;
Index: issm/trunk/src/c/Bamgx/objects/QuadTree.cpp
===================================================================
--- issm/trunk/src/c/Bamgx/objects/QuadTree.cpp	(revision 3244)
+++ issm/trunk/src/c/Bamgx/objects/QuadTree.cpp	(revision 3245)
@@ -94,5 +94,5 @@
 		 throw ErrorException(__FUNCT__,exprintf("MaxISize <= MaxICoor"));
 	 }
-	 for (long i=0;i<nbv;i++) 
+	 for (int i=0;i<nbv;i++) 
 	  Add(t->vertices[i]);
 	}
Index: issm/trunk/src/c/Bamgx/objects/SetOfE4.cpp
===================================================================
--- issm/trunk/src/c/Bamgx/objects/SetOfE4.cpp	(revision 3244)
+++ issm/trunk/src/c/Bamgx/objects/SetOfE4.cpp	(revision 3245)
@@ -20,5 +20,5 @@
 		NbOfEdges=0;
 		head = new long [nx];
-		Edges= new Int4Edge[nbax];
+		Edges= new IntEdge[nbax];
 
 		//initialize head (-1 everywhere)
Index: issm/trunk/src/c/Bamgx/objects/SetOfE4.h
===================================================================
--- issm/trunk/src/c/Bamgx/objects/SetOfE4.h	(revision 3244)
+++ issm/trunk/src/c/Bamgx/objects/SetOfE4.h	(revision 3245)
@@ -6,5 +6,5 @@
 	class SetOfEdges4;
 
-	class Int4Edge{
+	class IntEdge{
 		friend class SetOfEdges4;
 		public:
@@ -18,5 +18,5 @@
 			long nx,nbax,NbOfEdges;
 			long* head; 
-			Int4Edge* Edges;
+			IntEdge* Edges;
 
 		public:
@@ -33,5 +33,5 @@
 
 			//operators
-			Int4Edge & operator[](long k){return  Edges[k];}
+			IntEdge & operator[](long k){return  Edges[k];}
 	};
 }
Index: issm/trunk/src/c/Bamgx/objects/Triangles.cpp
===================================================================
--- issm/trunk/src/c/Bamgx/objects/Triangles.cpp	(revision 3244)
+++ issm/trunk/src/c/Bamgx/objects/Triangles.cpp	(revision 3245)
@@ -884,5 +884,5 @@
 
 		//loop over all the vertices on edges
-		for (long  i=0;i<nbe;i++){
+		for (int  i=0;i<nbe;i++){
 			for (int j=0;j<2;j++){
 
@@ -1085,5 +1085,5 @@
 
 		//loop over all vertices
-		for (long i=0;i<nbv;i++){
+		for (int i=0;i<nbv;i++){
 			MatVVP2x2 Vp(vertices[i]);
 			double lmax=Vp.lmax();
@@ -1655,5 +1655,5 @@
 
 		//for all Solutions
-		for (long nusol=0;nusol<nbsol;nusol++) {
+		for (int nusol=0;nusol<nbsol;nusol++) {
 			double smin=ss[nusol],smax=ss[nusol];
 
@@ -1861,5 +1861,5 @@
 
 		//for all Solution  
-		for (long nusol=0;nusol<nbsol;nusol++) {
+		for (int nusol=0;nusol<nbsol;nusol++) {
 
 			double smin=ss[nusol],smax=ss[nusol];
@@ -2208,5 +2208,5 @@
 
 			//check that there is no triangle with 0 determinant
-			for (long t = 0; t < nbt; t++){
+			for (int t = 0; t < nbt; t++){
 				if (!triangles[t].det) k++;
 			}
@@ -2217,5 +2217,5 @@
 			//Force Edges
 			TriangleAdjacent ta(0,0);
-			for (long i = 0; i < nbe; i++){
+			for (int i = 0; i < nbe; i++){
 
 				//Force edge i
@@ -2226,5 +2226,5 @@
 				if (nbswp) nbfe++;
 				if ( nbswp < 0 && k < 5){
-					for (long j = 0; j < nbe; j++){
+					for (int j = 0; j < nbe; j++){
 						printf("Edge %i: %i %i\n",j,Number(edges[j][0]),Number(edges[j][1]));
 					}
@@ -2238,5 +2238,5 @@
 				throw ErrorException(__FUNCT__,exprintf("There are %i lost edges, the boundary might be crossing",k));
 			}
-			for (long j=0;j<nbv;j++){
+			for (int j=0;j<nbv;j++){
 				Nbswap +=  vertices[j].Optim(1,0);
 			}
@@ -2257,5 +2257,5 @@
 		long k,it;
 
-		for (long itt=0;itt<nbt;itt++) 
+		for (int itt=0;itt<nbt;itt++) 
 		 triangles[itt].link=0; // par defaut pas de couleur
 
@@ -2415,5 +2415,5 @@
 				 mark[it]=triangles[it].link ? -1 : -2;
 				long inew =0;
-				for (long i=0;i<NbSubDomains;i++) {
+				for (int i=0;i<NbSubDomains;i++) {
 					GeometricalEdge &eg = *Gh.subdomains[i].edge;
 					subdomains[i].ref = Gh.subdomains[i].ref;
@@ -2745,5 +2745,5 @@
 		// We add the vertices one by one
 		long NbSwap=0;
-		for (long icount=2; icount<nbvb; icount++) {
+		for (int icount=2; icount<nbvb; icount++) {
 			Vertex *vi  = ordre[icount];
 			Icoor2 dete[3];
@@ -3633,5 +3633,5 @@
 		if (verbosity>3) printf("   Begining of insertion process...\n");
 
-		for (long icount=2; icount<nbv; icount++) {
+		for (int icount=2; icount<nbv; icount++) {
 
 			//Get new vertex
@@ -3702,5 +3702,5 @@
 		long k3 = rand()%nbvnew;
 		//loop over the new points
-		for (long is3=0; is3<nbvnew; is3++){
+		for (int is3=0; is3<nbvnew; is3++){
 			register long j=nbvold +(k3 = (k3+PrimeNumber)%nbvnew);
 			register long i=nbvold+is3; 
@@ -3808,5 +3808,5 @@
 
 			long nbqq = (nbt*3)/2;
-			DoubleAndInt4 *qq = new DoubleAndInt4[nbqq];
+			DoubleAndInt *qq = new DoubleAndInt[nbqq];
 
 			long i,ij;
@@ -5276,5 +5276,5 @@
 		long NbSwap = 0;
 		Icoor2 dete[3];  
-		for (long i=nbvold;i<nbv;i++) {// for all the new point
+		for (int i=nbvold;i<nbv;i++) {// for all the new point
 			Vertex & vi = vertices[i];
 			vi.i = toI2(vi.r);
@@ -5317,8 +5317,8 @@
 
 	//initialize all triangles as -1 (outside)
-	for (long it=0;it<nbt;it++) reft[it]=-1;
+	for (int it=0;it<nbt;it++) reft[it]=-1;
 
 	//loop over all subdomains
-	for (long i=0;i<NbSubDomains;i++){ 
+	for (int i=0;i<NbSubDomains;i++){ 
 
 		//first triangle of the subdomain i
Index: issm/trunk/src/c/Bamgx/objects/Triangles.h
===================================================================
--- issm/trunk/src/c/Bamgx/objects/Triangles.h	(revision 3244)
+++ issm/trunk/src/c/Bamgx/objects/Triangles.h	(revision 3245)
@@ -10,5 +10,5 @@
 #include "Metric.h"
 #include "SetOfE4.h"
-#include "DoubleAndInt4.h"
+#include "DoubleAndInt.h"
 #include "Direction.h"
 #include "Vertex.h"
Index: issm/trunk/src/c/Makefile.am
===================================================================
--- issm/trunk/src/c/Makefile.am	(revision 3244)
+++ issm/trunk/src/c/Makefile.am	(revision 3245)
@@ -336,5 +336,5 @@
 					./Bamgx/objects/Curve.h\
 					./Bamgx/objects/Direction.h\
-					./Bamgx/objects/DoubleAndInt4.h\
+					./Bamgx/objects/DoubleAndInt.h\
 					./Bamgx/objects/Edge.h\
 					./Bamgx/objects/GeometricalEdge.cpp\
@@ -702,5 +702,5 @@
 					./Bamgx/objects/Curve.h\
 					./Bamgx/objects/Direction.h\
-					./Bamgx/objects/DoubleAndInt4.h\
+					./Bamgx/objects/DoubleAndInt.h\
 					./Bamgx/objects/Edge.h\
 					./Bamgx/objects/GeometricalEdge.cpp\